From 37c8bc138378f9daabf58b9b6a2f07eccc255e89 Mon Sep 17 00:00:00 2001
From: "Robert A. Burks" <rburksdev@gmail.com>
Date: Mon, 18 Mar 2024 02:15:59 -0400
Subject: [PATCH 19/31] * Add ert for missing 'where' makunbound watcher bug
 (BUG#00005)

* test/src/data-tests.el (data-tests-makunbound-watcher-bug00005):
---
 test/src/data-tests.el | 31 +++++++++++++++++++++++++++++++
 1 file changed, 31 insertions(+)

diff --git a/test/src/data-tests.el b/test/src/data-tests.el
index 3d924309c32..41913a1a4ad 100644
--- a/test/src/data-tests.el
+++ b/test/src/data-tests.el
@@ -905,6 +905,37 @@ data-tests-local-variable-watcher-bug00004
     (should (equal (pop r1) `(,v1 nil makunbound ,b1)))
     (should (null  r1))))
 
+;; BUG#00005
+(ert-deftest data-tests-makunbound-watcher-bug00005  ()
+  (let* ((r1 nil)       ;; results
+         (b1 nil)       ;; buffer
+         (v1 (gensym))  ;; local in some buffer
+         (v2 (gensym))  ;; local if set
+         (f1 (lambda (&rest args) (push args r1))))
+    (with-no-warnings
+      (make-variable-buffer-local v2))
+    (add-variable-watcher v1 f1)
+    (add-variable-watcher v2 f1)
+    (with-temp-buffer
+      (setq b1 (current-buffer))
+      (make-local-variable v1)
+      (set v1 200)
+      (makunbound v1))
+    (makunbound v1)
+    (should (equal (pop r1) `(,v1 nil makunbound nil)))
+    (should (equal (pop r1) `(,v1 nil makunbound ,b1)))
+    (should (equal (pop r1) `(,v1 200 set ,b1)))
+    (should (null  r1))
+    (with-temp-buffer
+      (setq b1 (current-buffer))
+      (set v2 200)
+      (makunbound v2))
+    (makunbound v2)
+    (should (equal (pop r1) `(,v2 nil makunbound ,(current-buffer))))
+    (should (equal (pop r1) `(,v2 nil makunbound ,b1)))
+    (should (equal (pop r1) `(,v2 200 set ,b1)))
+    (should (null  r1))))
+
 (ert-deftest data-tests-kill-all-local-variables () ;bug#30846
   (with-temp-buffer
     (setq-local data-tests-foo1 1)
-- 
2.34.1

